using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Tekla.Structures;
using Tekla.Structures.Filtering;
using Tekla.Structures.Filtering.Categories;
using Tekla.Structures.Model;
using Tekla.Structures.Model.UI;
using System.IO;
using Tekla.Technology.Akit.UserScript;
using Tekla.Technology.Scripting;
using System.Diagnostics;


namespace Tekla.Technology.Akit.UserScript
{
  partial class FindAssForm: System.Windows.Forms.Form
    {
        private System.Windows.Forms.ContextMenuStrip contextMenuStrip1;
        private System.Windows.Forms.ToolStripMenuItem выбратьВМоделиToolStripMenuItem;
        private System.Windows.Forms.ToolStripMenuItem показатьВыбранноеToolStripMenuItem;
        private System.Windows.Forms.ToolStripMenuItem скрытьВыбранноеToolStripMenuItem;
        private System.Windows.Forms.ToolStripMenuItem обнвитьПространствоМоделиToolStripMenuItem;
        private System.Windows.Forms.LinkLabel labelMO;
        private System.Windows.Forms.TabControl tabControl1;
        private System.Windows.Forms.TabPage tabPageAssPos;
        private System.Windows.Forms.ComboBox FindSW;
        private System.Windows.Forms.TextBox FindText;
        private System.Windows.Forms.Button FindButton;
        private System.Windows.Forms.TreeView treeView1;
        private System.Windows.Forms.TabPage tabPageIDGuid;
        private System.Windows.Forms.LinkLabel linkLabelMOh;
        private System.Windows.Forms.LinkLabel linkLabel1;
        private System.Windows.Forms.TextBox textBoxID;
        private System.Windows.Forms.ToolStripSeparator toolStripSeparator1;
        private System.Windows.Forms.ToolStripMenuItem OpenChert;
        private System.Windows.Forms.Button AssButton;
		private System.Windows.Forms.LinkLabel linkLabel2;

        private System.ComponentModel.IContainer components = null;

        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
             this.components = new System.ComponentModel.Container();
            this.contextMenuStrip1 = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.выбратьВМоделиToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.показатьВыбранноеToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.скрытьВыбранноеToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.обнвитьПространствоМоделиToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.labelMO = new System.Windows.Forms.LinkLabel();
            this.tabControl1 = new System.Windows.Forms.TabControl();
            this.tabPageAssPos = new System.Windows.Forms.TabPage();
            this.FindSW = new System.Windows.Forms.ComboBox();
            this.FindText = new System.Windows.Forms.TextBox();
            this.FindButton = new System.Windows.Forms.Button();
            this.treeView1 = new System.Windows.Forms.TreeView();
            this.tabPageIDGuid = new System.Windows.Forms.TabPage();
            this.linkLabelMOh = new System.Windows.Forms.LinkLabel();
            this.linkLabel1 = new System.Windows.Forms.LinkLabel();
			this.linkLabel2 = new System.Windows.Forms.LinkLabel();
            this.textBoxID = new System.Windows.Forms.TextBox();
            this.toolStripSeparator1 = new System.Windows.Forms.ToolStripSeparator();
            this.OpenChert = new System.Windows.Forms.ToolStripMenuItem();
            this.AssButton = new System.Windows.Forms.Button();
            this.contextMenuStrip1.SuspendLayout();
            this.tabControl1.SuspendLayout();
            this.tabPageAssPos.SuspendLayout();
            this.tabPageIDGuid.SuspendLayout();
            this.SuspendLayout();
            // 
            // contextMenuStrip1
            // 
            this.contextMenuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.выбратьВМоделиToolStripMenuItem,
            this.показатьВыбранноеToolStripMenuItem,
            this.скрытьВыбранноеToolStripMenuItem,
            this.обнвитьПространствоМоделиToolStripMenuItem,
            this.toolStripSeparator1,
            this.OpenChert});
            this.contextMenuStrip1.Name = "contextMenuStrip1";
            this.contextMenuStrip1.Size = new System.Drawing.Size(274, 120);
            // 
            // выбратьВМоделиToolStripMenuItem
            // 
            this.выбратьВМоделиToolStripMenuItem.Name = "выбратьВМоделиToolStripMenuItem";
            this.выбратьВМоделиToolStripMenuItem.ShortcutKeys = System.Windows.Forms.Keys.Insert;
            this.выбратьВМоделиToolStripMenuItem.Size = new System.Drawing.Size(273, 22);
            this.выбратьВМоделиToolStripMenuItem.Text = "Выбрать в модели";
            this.выбратьВМоделиToolStripMenuItem.Click += new System.EventHandler(this.выбратьВМоделиToolStripMenuItem_Click);
            // 
            // показатьВыбранноеToolStripMenuItem
            // 
            this.показатьВыбранноеToolStripMenuItem.Name = "показатьВыбранноеToolStripMenuItem";
            this.показатьВыбранноеToolStripMenuItem.ShortcutKeys = ((System.Windows.Forms.Keys)((System.Windows.Forms.Keys.Control | System.Windows.Forms.Keys.H)));
            this.показатьВыбранноеToolStripMenuItem.Size = new System.Drawing.Size(273, 22);
            this.показатьВыбранноеToolStripMenuItem.Text = "Показать только выбранное";
            this.показатьВыбранноеToolStripMenuItem.Click += new System.EventHandler(this.показатьВыбранноеToolStripMenuItem_Click);
            // 
            // скрытьВыбранноеToolStripMenuItem
            // 
            this.скрытьВыбранноеToolStripMenuItem.Name = "скрытьВыбранноеToolStripMenuItem";
            this.скрытьВыбранноеToolStripMenuItem.ShortcutKeys = ((System.Windows.Forms.Keys)((System.Windows.Forms.Keys.Control | System.Windows.Forms.Keys.U)));
            this.скрытьВыбранноеToolStripMenuItem.Size = new System.Drawing.Size(273, 22);
            this.скрытьВыбранноеToolStripMenuItem.Text = "Скрыть выбранное";
            this.скрытьВыбранноеToolStripMenuItem.Click += new System.EventHandler(this.скрытьВыбранноеToolStripMenuItem_Click);
            // 
            // обнвитьПространствоМоделиToolStripMenuItem
            // 
            this.обнвитьПространствоМоделиToolStripMenuItem.Name = "обнвитьПространствоМоделиToolStripMenuItem";
            this.обнвитьПространствоМоделиToolStripMenuItem.Size = new System.Drawing.Size(273, 22);
            this.обнвитьПространствоМоделиToolStripMenuItem.Text = "Обновить пространство модели";
            this.обнвитьПространствоМоделиToolStripMenuItem.Click += new System.EventHandler(this.обнвитьПространствоМоделиToolStripMenuItem_Click);
            // 
            // labelMO
            // 
            this.labelMO.AutoSize = true;
            this.labelMO.Location = new System.Drawing.Point(17, 52);
            this.labelMO.Name = "labelMO";
            this.labelMO.Size = new System.Drawing.Size(0, 13);
            this.labelMO.TabIndex = 7;
            this.labelMO.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.labelMO_LinkClicked);
            // 
            // tabControl1
            // 
            this.tabControl1.Controls.Add(this.tabPageAssPos);
            this.tabControl1.Controls.Add(this.tabPageIDGuid);
            this.tabControl1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tabControl1.Location = new System.Drawing.Point(0, 0);
            this.tabControl1.Name = "tabControl1";
            this.tabControl1.SelectedIndex = 0;
            this.tabControl1.Size = new System.Drawing.Size(537, 387);
            this.tabControl1.TabIndex = 10;
            // 
            // tabPageAssPos
            // 
            this.tabPageAssPos.Controls.Add(this.AssButton);
            this.tabPageAssPos.Controls.Add(this.FindSW);
            this.tabPageAssPos.Controls.Add(this.FindText);
            this.tabPageAssPos.Controls.Add(this.FindButton);
            this.tabPageAssPos.Controls.Add(this.treeView1);
            this.tabPageAssPos.Location = new System.Drawing.Point(4, 22);
            this.tabPageAssPos.Name = "tabPageAssPos";
            this.tabPageAssPos.Padding = new System.Windows.Forms.Padding(3);
            this.tabPageAssPos.Size = new System.Drawing.Size(529, 361);
            this.tabPageAssPos.TabIndex = 0;
            this.tabPageAssPos.Text = "Поиск марок/позиций";
            this.tabPageAssPos.UseVisualStyleBackColor = true;
            // 
            // FindSW
            // 
            this.FindSW.FormattingEnabled = true;
            this.FindSW.Location = new System.Drawing.Point(3, 39);
            this.FindSW.Name = "FindSW";
            this.FindSW.Size = new System.Drawing.Size(119, 21);
            this.FindSW.TabIndex = 7;
            // 
            // FindText
            // 
            this.FindText.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.FindText.Location = new System.Drawing.Point(128, 40);
            this.FindText.Name = "FindText";
            this.FindText.Size = new System.Drawing.Size(395, 20);
            this.FindText.TabIndex = 4;
            // 
            // FindButton
            // 
            this.FindButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.FindButton.Location = new System.Drawing.Point(128, 10);
            this.FindButton.Name = "FindButton";
            this.FindButton.Size = new System.Drawing.Size(388, 24);
            this.FindButton.TabIndex = 5;
            this.FindButton.Text = "Искать";
            this.FindButton.UseVisualStyleBackColor = true;
            this.FindButton.Click += new System.EventHandler(this.FindButF_Click);
            // 
            // treeView1
            // 
            this.treeView1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.treeView1.ContextMenuStrip = this.contextMenuStrip1;
            this.treeView1.FullRowSelect = true;
            this.treeView1.Location = new System.Drawing.Point(3, 66);
            this.treeView1.Name = "treeView1";
            this.treeView1.Size = new System.Drawing.Size(520, 289);
            this.treeView1.TabIndex = 6;
            this.treeView1.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView1_AfterSelect);
            // 
            // tabPageIDGuid
            // 
            this.tabPageIDGuid.Controls.Add(this.linkLabelMOh);
            this.tabPageIDGuid.Controls.Add(this.labelMO);
            this.tabPageIDGuid.Controls.Add(this.linkLabel1);
			this.tabPageIDGuid.Controls.Add(this.linkLabel2);
            this.tabPageIDGuid.Controls.Add(this.textBoxID);
            this.tabPageIDGuid.Location = new System.Drawing.Point(4, 22);
            this.tabPageIDGuid.Name = "tabPageIDGuid";
            this.tabPageIDGuid.Padding = new System.Windows.Forms.Padding(3);
            this.tabPageIDGuid.Size = new System.Drawing.Size(529, 361);
            this.tabPageIDGuid.TabIndex = 1;
            this.tabPageIDGuid.Text = "Поиск по ID/GUID";
            this.tabPageIDGuid.UseVisualStyleBackColor = true;
            // 
            // linkLabelMOh
            // 
            this.linkLabelMOh.AutoSize = true;
            this.linkLabelMOh.LinkColor = System.Drawing.Color.Silver;
            this.linkLabelMOh.Location = new System.Drawing.Point(17, 78);
            this.linkLabelMOh.Name = "linkLabelMOh";
            this.linkLabelMOh.Size = new System.Drawing.Size(0, 13);
            this.linkLabelMOh.TabIndex = 11;
            this.linkLabelMOh.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelMOh_LinkClicked);
            // 
            // linkLabel1
            // 
            this.linkLabel1.AutoSize = true;
            this.linkLabel1.LinkColor = System.Drawing.Color.Red;
            this.linkLabel1.Location = new System.Drawing.Point(17, 13);
            this.linkLabel1.Name = "linkLabel1";
            this.linkLabel1.Size = new System.Drawing.Size(50, 13);
            this.linkLabel1.TabIndex = 10;
            this.linkLabel1.TabStop = true;
            this.linkLabel1.Text = "ID/GUID";
            this.linkLabel1.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel1_LinkClicked);
            // 
            // textBoxID
            // 
            this.textBoxID.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.textBoxID.Location = new System.Drawing.Point(73, 10);
            this.textBoxID.Name = "textBoxID";
            this.textBoxID.Size = new System.Drawing.Size(427, 20);
            this.textBoxID.TabIndex = 9;
            this.textBoxID.TextChanged += new System.EventHandler(this.textBoxID_TextChanged);
            // 
            // toolStripSeparator1
            // 
            this.toolStripSeparator1.Name = "toolStripSeparator1";
            this.toolStripSeparator1.Size = new System.Drawing.Size(270, 6);
            // 
            // OpenChert
            // 
            this.OpenChert.Name = "OpenChert";
            this.OpenChert.Size = new System.Drawing.Size(273, 22);
            this.OpenChert.Text = "Открыть чертеж";
            // 
            // AssButton
            // 
            this.AssButton.Location = new System.Drawing.Point(3, 10);
            this.AssButton.Name = "AssButton";
            this.AssButton.Size = new System.Drawing.Size(118, 24);
            this.AssButton.TabIndex = 8;
            this.AssButton.Tag = "True";
            this.AssButton.Text = "Ищем марки";
            this.AssButton.UseVisualStyleBackColor = true;
            this.AssButton.Click += new System.EventHandler(this.AssButton_Click_1);
			// 
            // linkLabel2
            // 
            this.linkLabel2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.linkLabel2.AutoSize = true;
            this.linkLabel2.Location = new System.Drawing.Point(410, 345);
            this.linkLabel2.Name = "linkLabel2";
            this.linkLabel2.Size = new System.Drawing.Size(80, 13);
            this.linkLabel2.TabIndex = 12;
            this.linkLabel2.TabStop = true;
            this.linkLabel2.Text = @"http:\\Forum.ZlatIng.ru";
			this.linkLabel2.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel2_LinkClicked);
            // 
            // FindAssForm
            // 
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.None;
            this.ClientSize = new System.Drawing.Size(537, 387);
            this.Controls.Add(this.tabControl1);
            this.Name = "FindAssForm";
            this.Text = "Найти марку";
            this.TopMost = true;
            this.contextMenuStrip1.ResumeLayout(false);
            this.tabControl1.ResumeLayout(false);
            this.tabPageAssPos.ResumeLayout(false);
            this.tabPageAssPos.PerformLayout();
            this.tabPageIDGuid.ResumeLayout(false);
            this.tabPageIDGuid.PerformLayout();
            this.ResumeLayout(false);

        }
	
		Model M = new Model();
        String sysPath = "";
      
        public FindAssForm()
        {
            InitializeComponent();
            sysPath = M.GetInfo().ModelPath;
            sysPath = Path.Combine(sysPath, "attributes");
            sysPath = Path.Combine(sysPath, "AF.SObjGrp");
            FindSW.Items.Add("Начинается с");
            FindSW.Items.Add("Содержит");
            FindSW.Items.Add("Равно");
            FindSW.Items.Add("Не содержит");
            FindSW.Items.Add("Заканчивается на");
            FindSW.Items.Add("Не равно");
            FindSW.Text = "Начинается с";
            AssButton.Tag = true;
        }


        private void FindButF_Click(object sender, EventArgs e)
        {
            CreateFilterFile();
            treeView1.Nodes.Clear();
            this.Cursor = Cursors.WaitCursor;
            ModelObjectEnumerator ME = M.GetModelObjectSelector().GetObjectsByFilterName("AF");
            ME.SelectInstances = false;
            string ASSEMBLY_POSITION = "";
            string ASSEMBLY_NAME = "";
            string DR_name = "";
            while (ME.MoveNext())
            {
                ModelObject tAss = ME.Current;
                if (tAss is Assembly & (bool)AssButton.Tag)
                {
                    tAss.GetReportProperty("ASSEMBLY_POS", ref ASSEMBLY_POSITION);
                    tAss.GetReportProperty("DRAWING.NAME", ref DR_name);
                    ASSEMBLY_POSITION = ASSEMBLY_POSITION.PadRight(10,' ')+ DR_name;
                    TreeNodeCollection favNode=treeView1.Nodes;
                    TreeNode[] fNode = treeView1.Nodes.Find(ASSEMBLY_POSITION,false);
                    if (fNode.Count() > 0)
                    {
                        TreeNode grNode = fNode[0];
                        favNode = grNode.Nodes;
                        if (grNode.Tag is Assembly)
                        {
                            TreeNode ngNode = grNode.Nodes.Add(grNode.Text);
                            ngNode.Tag = grNode.Tag;
                            grNode.Tag = "GR";
                        }
                    }
                    TreeNode nNode = favNode.Add(ASSEMBLY_POSITION);
                    nNode.Tag = tAss;
                    nNode.Name = ASSEMBLY_POSITION; 
                }
                if (tAss is Part & !(bool)AssButton.Tag)
                {
                    tAss.GetReportProperty("PART_POS", ref ASSEMBLY_POSITION);
                    tAss.GetReportProperty("ASSEMBLY_POS", ref ASSEMBLY_NAME);
                    tAss.GetReportProperty("DRAWING.NAME", ref DR_name);
                    ASSEMBLY_POSITION = ASSEMBLY_POSITION.PadRight(10, ' ') + ASSEMBLY_NAME.PadRight(10, ' ') + DR_name;
                    TreeNodeCollection favNode = treeView1.Nodes;
                    TreeNode[] fNode = treeView1.Nodes.Find(ASSEMBLY_POSITION, false);
                    if (fNode.Count() > 0)
                    {
                        TreeNode grNode = fNode[0];
                        favNode = grNode.Nodes;
                        if (grNode.Tag is Part)
                        {
                            TreeNode ngNode = grNode.Nodes.Add(grNode.Text);
                            ngNode.Tag = grNode.Tag;
                            grNode.Tag = "GR";
                        }
                    }
                    TreeNode nNode = favNode.Add(ASSEMBLY_POSITION);
                    nNode.Tag = tAss;
                    nNode.Name = ASSEMBLY_POSITION; 
                }
            }
            this.Cursor = Cursors.Default;
            if ((bool)AssButton.Tag) { RunMacros("select_assemblies"); }
            else { RunMacros("sel_objects_in_joints"); }
        }

        private void CreateFilterFile()
        {
          
            StreamWriter FF = new StreamWriter(sysPath,false,Encoding.Default);
            FF.WriteLine("TITLE_OBJECT_GROUP");
            FF.WriteLine("{");
            FF.WriteLine("    Version= 1.05");
            FF.WriteLine("    Count= 2 ");
            FF.WriteLine("    SECTION_OBJECT_GROUP");
            FF.WriteLine("    {");
            FF.WriteLine("        0");
            FF.WriteLine("        1");
            if ((bool)AssButton.Tag)
            {
                FF.WriteLine("        co_assembly");
                FF.WriteLine("        proASSEMBLY_POSITION");
                FF.WriteLine("        albl_Position_number");
            }
            else
            {
                FF.WriteLine("        co_part");
                FF.WriteLine("        proNUMBERING_POSITION");
                FF.WriteLine("        albl_Position_number");
            }
            switch (FindSW.Text)
            {
                case "Равно":
                    FF.WriteLine("        ==");
                    FF.WriteLine("        albl_Equals");
                    break;
                case "Начинается с":
                    FF.WriteLine("        *BEGINS*");
                    FF.WriteLine("        albl_BeginsWith");
                    break;
                case "Содержит":
                    FF.WriteLine("        *CONTAINS*");
                    FF.WriteLine("        albl_Contains");
                    break;
                case "Не содержит":
                    FF.WriteLine("        *NOTCONTAINS*");
                    FF.WriteLine("        albl_DoesNotContain");
                    break;
                case "Заканчивается на":
                    FF.WriteLine("        *ENDS*");
                    FF.WriteLine("        albl_EndsWith");
                    break;
                case "Не равно":
                    FF.WriteLine("        !=");
                    FF.WriteLine("        albl_DoesNotEqual");
                    break;
                default:
                    FF.WriteLine("        ==");
                    FF.WriteLine("        albl_Equals");
                    break;
            }
            FF.WriteLine("        " + FindText.Text);
            FF.WriteLine("        0");
            FF.WriteLine("        &&");
            FF.WriteLine("        }");
            FF.WriteLine(" SECTION_OBJECT_GROUP ");
            FF.WriteLine("    {");
            FF.WriteLine("        0 ");
            FF.WriteLine("       1 ");
            FF.WriteLine("       co_object ");
            FF.WriteLine("        proOBJECT_TYPE ");
            FF.WriteLine("       albl_ObjectType ");
            FF.WriteLine("        == ");
            FF.WriteLine("        albl_Equals ");
            if ((bool)AssButton.Tag)
            {
                FF.WriteLine("        albl_Assembly ");
            }
            else
            {
                FF.WriteLine("        albl_Part ");
            }
            FF.WriteLine("        0 ");
            FF.WriteLine("        && ");
            FF.WriteLine("        }");            
            FF.WriteLine("    }");
            FF.Close();
        }

        private void SelectNode(TreeNode tn)
        {
            if (tn == null)
            {
                return;
            }
            if (tn.Tag is Assembly | tn.Tag is Part | tn.Tag.ToString() == "GR")
            {
                ArrayList sel = new ArrayList();
                if (tn.Tag is Assembly|tn.Tag is Part)
                {
                    sel.Add(tn.Tag);
                }
                else
                {
                    foreach (TreeNode trn in tn.Nodes)
                    {
                        sel.Add(trn.Tag);
                    }
                }
                Tekla.Structures.Model.UI.ModelObjectSelector MS = new Tekla.Structures.Model.UI.ModelObjectSelector();
                MS.Select(sel);               
            }
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            SelectNode(e.Node);
            Tekla.Structures.ModelInternal.Operation.dotStartAction("ZoomToSelected", "");
        }

        private void обнвитьПространствоМоделиToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Tekla.Structures.ModelInternal.Operation.dotStartAction("RedrawAll", "");
        }

        private void выбратьВМоделиToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TreeNode tn = treeView1.SelectedNode;
            SelectNode(tn);
            Tekla.Structures.ModelInternal.Operation.dotStartAction("ZoomToSelected", "");
        }

        private void показатьВыбранноеToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TreeNode tn = treeView1.SelectedNode;
            SelectNode(tn);
            Tekla.Structures.ModelInternal.Operation.dotStartAction("HideUnselectedObjects", "");
        }

        private void скрытьВыбранноеToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TreeNode tn = treeView1.SelectedNode;
            SelectNode(tn);
            Tekla.Structures.ModelInternal.Operation.dotStartAction("HideSelectedObjects", "");
        }

        private void FindText_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar==(Char)13)
            {
                FindButF_Click(null, null);
            }
        }

        private void textBoxID_TextChanged(object sender, EventArgs e)
        {
            Int32 intID = 0;
            if (textBoxID.Text.Length == 38)
            {
                textBoxID.Text = textBoxID.Text.Remove(0, 2);
            }
            if (textBoxID.Text.Length == 36)
            {
                intID = 0;
                try
                {
                    Identifier id = M.GetIdentifierByGUID(textBoxID.Text);
                    intID = id.ID;
                    if (intID==0)
                    {
                        labelMO.Text = "";
                        labelMO.Tag = null;
                        linkLabelMOh.Text = "";
                        linkLabelMOh.Tag = null;
                        return;
                    }
                }
                catch
                {
                    labelMO.Text = "";
                    labelMO.Tag = null;
                    linkLabelMOh.Text = "";
                    linkLabelMOh.Tag = null;
                    return;
                }
            }

            if (textBoxID.Text.Length < 36)
            {
                try
                {
                    intID = Int32.Parse(textBoxID.Text);
                }
                catch
                {
                    labelMO.Text = "";
                    labelMO.Tag = null;
                    linkLabelMOh.Text = "";
                    linkLabelMOh.Tag = null;
                    return;
                }
            }            
            Identifier ID = new Identifier(intID);
            ModelObject mo = M.SelectModelObject(ID);
			if (mo!=null)
			{
            labelMO.Text = "Найти в модели "+mo.ToString();
            labelMO.Tag = mo;
            linkLabelMOh.Text = "Скрыть модель кроме "+mo.ToString();
            linkLabelMOh.Tag = mo;
			}
        }

        private void labelMO_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (labelMO.Tag is ModelObject)
            {
                ArrayList sel = new ArrayList();
                sel.Add(labelMO.Tag);
                Tekla.Structures.Model.UI.ModelObjectSelector MS = new Tekla.Structures.Model.UI.ModelObjectSelector();
                MS.Select(sel);
                Tekla.Structures.ModelInternal.Operation.dotStartAction("ZoomToSelected", "");
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (labelMO.Tag is ModelObject)
            {
                if (MessageBox.Show("Удалить объект " + labelMO.Tag.ToString() + " с ID:" + (labelMO.Tag as ModelObject).Identifier.ToString(), "Удаление", MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.Yes)
                {
                    ModelObject mo = (labelMO.Tag as ModelObject);
                    mo.Select();
                    mo.Delete();
                }
            }
        }

        private void linkLabelMOh_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            if (labelMO.Tag is ModelObject)
            {
                ArrayList sel = new ArrayList();
                sel.Add(labelMO.Tag);
                Tekla.Structures.Model.UI.ModelObjectSelector MS = new Tekla.Structures.Model.UI.ModelObjectSelector();
                MS.Select(sel);
                Tekla.Structures.ModelInternal.Operation.dotStartAction("ZoomToSelected", "");
                Tekla.Structures.ModelInternal.Operation.dotStartAction("HideUnselectedObjects", "");
            }
        }
 
        private void RunMacros(string comm)
        {
            string Name = GetMacroFileName();
            string MacrosPath = string.Empty;
            TeklaStructuresSettings.GetAdvancedOption("XS_MACRO_DIRECTORY", ref MacrosPath);
            File.WriteAllText(Path.Combine(MacrosPath, Name), "namespace Tekla.Technology.Akit.UserScript {public class Script {public static void Run(Tekla.Technology.Akit.IScript akit) {akit.ValueChange(\"main_frame\", \"" + comm + "\", \"1\");}}}");
			Tekla.Structures.Model.Operations.Operation.RunMacro("..\\" + Name);			
        }
        private string GetMacroFileName()
        {
            lock (Random)
            {
                if (_TempFileIndex < 0)
                {
                    _TempFileIndex = Random.Next(0, MaxTempFiles);
                }
                else
                {
                    _TempFileIndex = (_TempFileIndex + 1) % MaxTempFiles;
                }

                return string.Format(FileNameFormat, _TempFileIndex);
            }
        }
        private static int _TempFileIndex = -1;
        private static readonly Random Random = new Random();
        private const int MaxTempFiles = 32;
        private const string FileNameFormat = "macro_{0:00}.cs";

        private void AssButton_Click_1(object sender, EventArgs e)
        {
            AssButton.Tag = !(bool)AssButton.Tag;
            if ((bool)AssButton.Tag)
            {
                AssButton.Text = "Ищем марки";                
                Text = "Найти марку";
                RunMacros("select_assemblies");
            }
            else
            {
                AssButton.Text = "Ищем позиции";
                Text = "Найти позицию";
                RunMacros("sel_objects_in_joints");
            }
        }
		
		private void linkLabel2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start(linkLabel2.Text);
        }
    }

    public class Script
    {
        public static void Run(Tekla.Technology.Akit.IScript akit)
        {
            Application.EnableVisualStyles();
            Application.Run(new FindAssForm());
            
        }
    }

}